#pragma once
#include <sys/time.h>
#include <time.h>
#include <stdarg.h>
#include <stdio.h>  // perror
#include <stdlib.h> // exit

using namespace std;

typedef struct timeval TimeVal;

//-----------------------------------------------------------------------------
/**
@brief 出力の基本クラス
*/
class SGStream
{
public:
	SGStream();
	virtual ~SGStream();

	virtual int Output(char* string);
};

//-----------------------------------------------------------------------------
/**
@brief ログ
*/
class SGLog
{
public:
	SGLog();
	virtual ~SGLog();
	int LogPrintf(TimeVal time,const char *f, ...);
	int LogPrintf(const char *f, ...);
	int LogStart(int size,SGStream* srteam);
	int GetSize();
	SGStream *GetStream();

private:
	unsigned long long mStratTime; ///< @brief 開始時間
	int mBufferSize;               ///< @brief バッファサイズ
	char* mBuffer;                 ///< @brief バッファ
	SGStream* mSrteam;             ///< @brief 出力先
};
