#pragma once
#include "JsonParser.h"
#include "PGJsonCommand.h"
#include "PGJsonResource.h"

//-----------------------------------------------------------------------------
/**
@brief JSON パーサー

JSON 文字列を解析してオブジェクトに変換します。
*/
class PGJsonParser
{
  public:
	PGJsonParser();
	virtual ~PGJsonParser();

	bool ParseCommand( PGJsonCommands* jo, const SGString& json );
	bool ParseDialog( PGJsonResource* jo, const SGString& json, bool shard );
	bool MakeUpdateCommand( SGString& json, PGJsonResource* jo, bool allflag=false, const SGString& sessionid="");

	static PGJsonObject* CreateObject( const SGString &type, const SGString& layout, PGJsonObject* parent );
	static PGJsonObject* CreateCommand( const SGString &type );

	PGJsonObject* ParseObject( JsonParser& jp, PGJsonObject* parent, bool shard);
	int ParseList( PGJsonObject* jo, JsonParser& jp, bool shard);

  private:
	ostream& OutUpdateCommandRaw( ostream &out, PGJsonObject* jo, int& comma, bool allflag, const SGString& sessionid);
	ostream& OutDeleteCommandRaw( ostream &out, PGJsonObject* jo, int& comma);
	ostream& OutAddCommandRaw( ostream& out, PGJsonObject* jo, int& comma, int& indent, int create);
};
